/* sugerのポート設定テーブル */

/* 各configurationの入出力ポート数 */
/*                                 0  1  2  3  4  5   6   7  8  9  X */
static volatile uchar DIPorts[] = {0, 8, 8, 8, 8, 30, 0,  0, 0, 0, 8};
static volatile uchar DOPorts[] = {0, 8, 8, 8, 8, 0, 30, 30, 0, 0, 8};
static volatile uchar AIPorts[] = {0, 8, 8, 8, 8, 0,  0,  0, 0, 0, 0};
static volatile uchar AOPorts[] = {0, 6, 6, 6, 6, 0,  0,  0, 0, 0, 0};

/* 入出力ピンのマッピングテーブル */
static struct portInfo din8[] = { /* for config 1 */
  {&PINC,7},{&PINC,6},{&PINC,5},{&PINC,4},
  {&PINC,3},{&PINC,2},{&PINC,1},{&PINC,0}};

static struct portInfo din30[] = { /* for config 5 */
  {&PORTA,0},{&PORTA,1},{&PORTA,2},{&PORTA,3},
  {&PORTA,4},{&PORTA,5},{&PORTA,6},{&PORTA,7},
  {&PORTC,7},{&PORTC,6},{&PORTC,5},{&PORTC,4},
  {&PORTC,3},{&PORTC,2},{&PORTC,1},{&PORTC,0},
  {&PORTB,3},{&PORTB,4},{&PORTD,5},{&PORTD,4},
  {&PORTD,7},{&PORTD,6},
  {&PORTB,0},{&PORTB,1},{&PORTB,2},{&PORTB,5},
  {&PORTB,6},{&PORTB,7},{&PORTD,0},{&PORTD,1}};

static struct portInfo dout8[] = { /* for config 1 */
  {&PORTB,0},{&PORTB,1},{&PORTB,2},{&PORTB,5},
  {&PORTB,6},{&PORTB,7},{&PORTD,0},{&PORTD,1}};

static struct portInfo dout30[] = { /* for config 6 */
  {&PORTA,0},{&PORTA,1},{&PORTA,2},{&PORTA,3},
  {&PORTA,4},{&PORTA,5},{&PORTA,6},{&PORTA,7},
  {&PORTC,7},{&PORTC,6},{&PORTC,5},{&PORTC,4},
  {&PORTC,3},{&PORTC,2},{&PORTC,1},{&PORTC,0},
  {&PORTB,3},{&PORTB,4},{&PORTD,5},{&PORTD,4},
  {&PORTD,7},{&PORTD,6},
  {&PORTB,0},{&PORTB,1},{&PORTB,2},{&PORTB,5},
  {&PORTB,6},{&PORTB,7},{&PORTD,0},{&PORTD,1}};

/* Ainの情報は不要 */
static struct portInfo ain8[] = { /* for config 1 */
  {&PORTA,0},{&PORTA,1},{&PORTA,2},{&PORTA,3},
  {&PORTA,4},{&PORTA,5},{&PORTA,6},{&PORTA,7}};

static struct portInfo aout6[] = { /* for config 1 */
  {&OCR0A,0},{&OCR0B,0},
  {&OCR1AL,0},{&OCR1BL,0}, /* OCR1A,OCR1Bは16ビット */
  {&OCR2A,0},{&OCR2B,0}};
    
static volatile struct portMap portMapper[] = {
  {0,0,0,0},			/* config 0 (dummy) */
  {din8, dout8, ain8, aout6},	/* config 1 */
  {din8, dout8, ain8, aout6},	/* config 2(=1) */
  {din8, dout8, ain8, aout6},	/* config 3(=1) */
  {din8, dout8, ain8, aout6},	/* config 4(=1) */
  {din30, 0, 0, 0}, 		/* config 5 */
  {0, dout30, 0, 0}		/* config 6 */
};

static portConfig portConf[] = {
  /* A-IN A-OUT B-IN  B-OUT C-IN  C-OUT D-IN  D-OUT */
  { 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xf3, 0x00}, /* Config 0 */
  { 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0xf3}, /* Config 1 */
  { 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0xf3}, /* Config 2(=1) */
  { 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0xf3}, /* Config 3(=1) */
  { 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0xf3}, /* Config 4(=1) */
  { 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xf3, 0x00}, /* Config 5 */
  { 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xf3}, /* Config 6 */
};
